<template>
  <div class="infinite-loading-container">
    <div v-show="isLoading">
      <slot name="spinner">
        <i :class="spinnerType"></i>
      </slot>
    </div>
    <div class="infinite-status-prompt" v-show="!isLoading && isComplete && isFirstLoad">
      <slot name="no-results">İçerik bulunamadı</slot>
    </div>
    <div class="infinite-status-prompt" v-show="!isLoading && isComplete && !isFirstLoad">
      <slot name="no-more">İçeriğin sonuna geldik :)</slot>
    </div>
  </div>
</template>
<script>
  const spinnerMapping = {
    bubbles: 'loading-bubbles',
    circles: 'loading-circles',
    default: 'loading-default',
    spiral: 'loading-spiral',
    waveDots: 'loading-wave-dots'
  }

  /**
   * get the first scroll parent of an element
   * @param  {DOM} elm    the element which find scorll parent
   * @return {DOM}        the first scroll parent
   */
  // function getScrollParent (elm) {
  //   if (elm.tagName === 'BODY') {
  //     return window
  //   } else if (['scroll', 'auto'].indexOf(getComputedStyle(elm).overflowY) > -1) {
  //     return elm
  //   }
  //   return getScrollParent(elm.parentNode)
  // }

  /**
   * get current distance from footer
   * @param  {DOM} elm    scroll element
   * @param  {String} dir   calculate direction
   * @return {Number}     distance
   */
  function getCurrentDistance (elm, dir) {
    let distance
    const scrollTop = isNaN(elm.scrollTop) ? elm.pageYOffset : elm.scrollTop
    if (dir === 'top') {
      distance = scrollTop
    } else {
      const scrollElmHeight = elm === window
        ? window.innerHeight
        : elm.parentElement.clientHeight
        // : elm.getBoundingClientRect().height
      distance = this.$el.offsetTop - scrollTop - scrollElmHeight - (elm.offsetTop || 0)
    }
    return distance
  }

  function setDistanceOnce (elm, dir) {
    let distance
    const scrollTop = isNaN(elm.scrollTop) ? elm.pageYOffset : elm.scrollTop
    if (dir === 'top') {
      distance = scrollTop
    } else {
      distance = this.$el.offsetTop
    }
    return distance
  }
  
  export default {
    data () {
      return {
        scrollParent: null,
        scrollHandler: null,
        isLoading: false,
        isComplete: false,
        isFirstLoad: true, // save the current loading whether it is the first loading
        loaderDistance: 0
      }
    },
    computed: {
      spinnerType () {
        return spinnerMapping[this.spinner] || spinnerMapping.default
      }
    },
    props: {
      distance: {
        type: Number,
        default: 100
      },
      onInfinite: Function,
      spinner: String,
      direction: {
        type: String,
        default: 'bottom'
      },
      allLoaded: {
        type: Boolean,
        default: false
      }
    },
    mounted () {
      this.scrollParent = window

      this.scrollHandler = function scrollHandlerOriginal () {
        if (!this.isLoading) {
          this.attemptLoad()
        } else if (this.isLoading) {
          if (this.loaderDistance !== setDistanceOnce.bind(this)(this.scrollParent, this.direction)) {
            this.$emit('$infiniteLoading:loaded')
            this.loaderDistance = setDistanceOnce.bind(this)(this.scrollParent, this.direction)
          }
        }
      }.bind(this)

      setTimeout(this.scrollHandler, 1)
      this.scrollParent.addEventListener('scroll', this.scrollHandler)

      this.$on('$infiniteLoading:loaded', () => {
        this.isFirstLoad = false
        if (this.isLoading) {
          this.$nextTick(this.attemptLoad)
        }
      })
      this.$on('$infiniteLoading:complete', () => {
        this.isLoading = false
        this.isComplete = true
        this.scrollParent.removeEventListener('scroll', this.scrollHandler)
      })
      this.$on('$infiniteLoading:reset', () => {
        this.isLoading = false
        this.isComplete = false
        this.isFirstLoad = true
        this.scrollParent.addEventListener('scroll', this.scrollHandler)
        setTimeout(this.scrollHandler, 1)
      })
    },
    methods: {
      attemptLoad () {
        const currentDistance = getCurrentDistance.bind(this)(this.scrollParent, this.direction)
        if (!this.isComplete && currentDistance <= this.distance && !this.allLoaded) {
          this.isLoading = true
          this.onInfinite.call()
        } else if (this.allLoaded) {
          this.$emit('$infiniteLoading:complete')
        } else {
          this.isLoading = false
        }
      }
    },
    destroyed () {
      if (!this.isComplete) {
        this.scrollParent.removeEventListener('scroll', this.scrollHandler)
      }
    }
  }
</script>
<!--<style lang="less" scoped>
  @import '../styles/spinner';

  .infinite-loading-container{
    clear: both;
    text-align: center;
    *[class^=loading-]{
      @size: 28px;
      display: inline-block;
      margin: 15px 0;
      width: @size;
      height: @size;
      font-size: @size;
      line-height: @size;
      border-radius: 50%;
    }
  }

  .infinite-status-prompt{
    color: #666;
    font-size: 14px;
    text-align: center;
    padding: 10px 0;
  }
</style>-->
<style scoped>

.loading-default {
  position: relative;
  border: 1px solid #999;
  animation: ease loading-rotating 1.5s infinite;
}
.loading-default:before {
  content: '';
  position: absolute;
  display: block;
  top: 0;
  left: 50%;
  margin-top: -3px;
  margin-left: -3px;
  width: 6px;
  height: 6px;
  background-color: #999;
  border-radius: 50%;
}
.loading-spiral {
  border: 2px solid #777;
  border-right-color: transparent;
  animation: linear loading-rotating 0.85s infinite;
}
@keyframes loading-rotating {
  0% {
    transform: rotate(0);
  }
  100% {
    transform: rotate(360deg);
  }
}
.infinite-loading-container {
  clear: both;
  text-align: center;
}
.infinite-loading-container *[class^=loading-] {
  display: inline-block;
  margin: 15px 0;
  width: 28px;
  height: 28px;
  font-size: 28px;
  line-height: 28px;
  border-radius: 50%;
}
.infinite-status-prompt {
  color: #666;
  font-size: 14px;
  text-align: center;
  padding: 10px 0;
}

</style>
